package ru.ulstu.grant.repository;

import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import ru.ulstu.grant.model.Grant;
import ru.ulstu.user.model.User;

import java.util.List;

public interface GrantRepository extends JpaRepository<Grant, Integer> {
//    @Query(value =  "SELECT u.last_name " +
//                    "FROM users u, grants g " +
//                    "WHERE (g.leader_id = u.id) " +
//                    "AND (u.birth_date < 35) " +
//                    "AND (u.degree = 'CANDIDATE')" +
//                    "Group by u.last_name",
//                    nativeQuery = true)
//    List<User> filter(@Param("leader") Integer leader, @Param("birthYear") Date birthYear, @Param("degree") String degree);

    @Query("SELECT u.lastName FROM User u, Grant g WHERE (g.leader = u.id OR :leader IS FALSE) " +
            "AND (extract(year from interval (age(birth_date::date))) < 35 OR :birthDate IS FALSE) " +
            "AND (u.degree = 'CANDIDATE' OR :degree IS FALSE)" +
            "GROUP BY u.lastName")
    List<User> filterUsers(@Param("leader") boolean leader,
                           @Param("birthDate") boolean birthDate,
                           @Param("degree") boolean degree);

}
